Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 701734 - eclass/nvidia-driver.eclass: problem with version checking for warning message
Summary: eclass/nvidia-driver.eclass: problem with version checking for warning message
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Eclasses (show other bugs)
Hardware: All Linux
: Normal normal
Assignee: Jeroen Roovers (RETIRED)
URL:
Whiteboard:
Keywords: PATCH
Depends on:
Blocks:
 
Reported: 2019-12-02 08:10 UTC by Kobboi
Modified: 2019-12-02 10:14 UTC (History)
0 users

See Also:
Package list:
Runtime testing required: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Kobboi 2019-12-02 08:10:31 UTC
Recently I have been getting an irrelevant warning about using my Nvidia card's incompatibility with recent driver versions. I have the mask that is mentioned in place for a long time already. Likely related to recent changes to the eclass by jer.

https://gitweb.gentoo.org/repo/gentoo.git/commit/eclass/nvidia-driver.eclass?id=245f417b539760ccf4939630f2c6b826ce34a556

 * Messages for package x11-drivers/nvidia-drivers-390.132-r1:

 * ***** WARNING *****
 * 
 * You are currently installing a version of nvidia-drivers that is
 * known not to work with a GPU you have installed on your system.
 * If this is intentional, please ignore this. If it is not please
 * perform the following steps:
 * 
 * Add the following mask entry to the local package.mask file:
 * echo ">=x11-drivers/nvidia-drivers-391.0.0" > /etc/portage/package.mask/nvidia-drivers
 * 
 * Failure to perform the steps above could result in a non-working
 * X setup.
 * 
 * For more information please read:
 * http://www.nvidia.com/object/IO_32667.html

Reproducible: Always
Comment 1 Jeroen Roovers (RETIRED) gentoo-dev 2019-12-02 09:29:28 UTC
Which VID/PID is your PCI device?
Comment 2 Jeroen Roovers (RETIRED) gentoo-dev 2019-12-02 09:29:46 UTC
(In reply to Jeroen Roovers from comment #1)
> Which VID/PID is your PCI device?

Well, PID. VID is already known. :)
Comment 3 Jeroen Roovers (RETIRED) gentoo-dev 2019-12-02 09:34:46 UTC
Ah, maybe this is it.


diff --git a/eclass/nvidia-driver.eclass b/eclass/nvidia-driver.eclass
index b71b7a769ae..9dc4e87003c 100644
--- a/eclass/nvidia-driver.eclass
+++ b/eclass/nvidia-driver.eclass
@@ -175,12 +175,12 @@ nvidia-driver_get_mask() {

 # @FUNCTION: nvidia-driver_check_gpu
 # @DESCRIPTION:
-# Prints out a warning if the driver does not work w/ the installed video nvidia_gpu
+# Prints out a warning if the driver does not work with the installed GPU
 nvidia-driver_check_gpu() {
        local NVIDIA_MASK="$(nvidia-driver_get_mask)"

        if [ -n "${NVIDIA_MASK}" ]; then
-               if ! ver_test "${NVIDIA_MASK##*-}" -eq "${PV}" ; then
+               if ! ver_test "${NVIDIA_MASK##*-}" -ge "${PV}" ; then
                        ewarn "***** WARNING *****"
                        ewarn
                        ewarn "You are currently installing a version of nvidia-drivers that is"
Comment 4 Kobboi 2019-12-02 09:46:14 UTC
Well, not going to review all of the code, but at least I can confirm that I don't get the warning anymore :)
Comment 5 Larry the Git Cow gentoo-dev 2019-12-02 10:14:36 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=ab0fb1519721067734702a3d4f2fa91c968eaa34

commit ab0fb1519721067734702a3d4f2fa91c968eaa34
Author:     Jeroen Roovers <jer@gentoo.org>
AuthorDate: 2019-12-02 10:08:30 +0000
Commit:     Jeroen Roovers <jer@gentoo.org>
CommitDate: 2019-12-02 10:14:32 +0000

    nvidia-driver.eclass: Fix GPU vs version compatibility check
    
    - In commit 245f417b539760ccf4939630f2c6b826ce34a556 I replaced
    version_compare() with ver_test but failed to properly adjust the check
    from the "is at least" return value to its ver_test equivalent. Invert
    the test return value for clarity and check for a version mask less than
    PV.
    - Use lower case for local variable name.
    - Fix a comment while there.
    
    Fixes: https://bugs.gentoo.org/701734
    Signed-off-by: Jeroen Roovers <jer@gentoo.org>
    Tested-by: Kobboi
    Signed-off-by: Jeroen Roovers <jer@gentoo.org>

 eclass/nvidia-driver.eclass | 12 ++++++------
 1 file changed, 6 insertions(+), 6 deletions(-)